package net.sf.tomp.xml.type;

import net.sf.tomp.general.Parametrized;

import org.xml.sax.XMLFilter;

import java.util.*;

/**
 * DOCUMENT ME!
 *
 * @author $author$
 * @version $Revision$
 */
public class FilterTypeTransformation implements TypeTransformation
{
    /** DOCUMENT ME! */
    public static final double FILTER_COSTS = 1;

    /** DOCUMENT ME! */
    protected Class filterClass;

    /** DOCUMENT ME! */
    protected Map params = new HashMap();

    /**
     * Creates a new FilterTypeTransformation object.
     *
     * @param filterClassName DOCUMENT ME!
     * @throws ClassNotFoundException DOCUMENT ME!
     * @throws InstantiationException DOCUMENT ME!
     * @throws IllegalAccessException DOCUMENT ME!
     */
    public FilterTypeTransformation(String filterClassName)
        throws ClassNotFoundException, InstantiationException, 
            IllegalAccessException
    {
        filterClass = Class.forName(filterClassName);
    }

    /**
     * DOCUMENT ME!
     *
     * @param k DOCUMENT ME!
     * @param v DOCUMENT ME!
     * @throws UnsupportedOperationException DOCUMENT ME!
     */
    public void setParameter(String k, Object v)
    {
        if (Parametrized.class.isAssignableFrom(filterClass))
        {
            params.put(k, v);
        }
        else
        {
            throw new UnsupportedOperationException(
                "Cannot set parameters to non-parametrized filter " + this);
        }

        //System.out.println("Setting param "+k+"="+v);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     * @throws TypeTransformationException DOCUMENT ME!
     */
    public XMLFilter newFilter()
        throws TypeTransformationException
    {
        try
        {
            XMLFilter f = (XMLFilter) filterClass.newInstance();

            // fill params
            //System.out.println(" @"+Integer.toHexString(hashCode())+"
            // newFilter()=>"+f);
            if (f instanceof Parametrized)
            {
                for (Iterator i = params.entrySet().iterator(); i.hasNext();)
                {
                    Map.Entry e = (Map.Entry) i.next();
                    String k = (String) e.getKey();
                    Object v = e.getValue();

                    ((Parametrized) f).setParameter(k, v);
                }
            }

            return f;
        }
        catch (InstantiationException ie)
        {
            throw new TypeTransformationException(ie);
        }
        catch (IllegalAccessException ie)
        {
            throw new TypeTransformationException(ie);
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public double getCosts()
    {
        return FILTER_COSTS;
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String toString()
    {
        return "FilterTypeTransformation@" + Integer.toHexString(hashCode())
        + "(filterClass=" + filterClass + ")";
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public boolean isIdentity()
    {
        return false;
    }
}


/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
