package net.sf.tomp.xml.type;

import java.util.*;

/**
 * DOCUMENT ME!
 * 
 * @author $author$
 * @version $Revision$
 */
public class TypeImpl implements Type {
    /** DOCUMENT ME! */
    public static final boolean SHOW_PARENTS = false;

    /** DOCUMENT ME! */
    public static final Type UNKNOWN = new TypeImpl("UNKNOWN", "UNKNOWN");

    /** DOCUMENT ME! */
    protected String identification;

    /** DOCUMENT ME! */
    protected String type;

    /** DOCUMENT ME! */
    protected List parents = new ArrayList();

    /** DOCUMENT ME! */
    protected Map typesForContext = new HashMap();

    /**
     * Creates a new TypeImpl object.
     * 
     * @param t DOCUMENT ME!
     * @param i DOCUMENT ME!
     */
    public TypeImpl(String t, String i) {
        type = t;
        identification = i;
    }

    public boolean equals(Object o) {
        Type t = (Type) o;

        return getIdentification().equals(t.getIdentification())
                && getTypeType().equals(t.getTypeType());
    }

    public int hashCode() {
        return getIdentification().hashCode() ^ getTypeType().hashCode();
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String getIdentification() {
        return identification;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String getTypeType() {
        return type;
    }

    /**
     * DOCUMENT ME!
     * 
     * @param p DOCUMENT ME!
     */
    public void addParent(Type p) {
        parents.add(p);
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public Iterator parentIterator() {
        return parents.iterator();
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public Iterator ancestorIterator() {
        // FIXME: only parents, not further ancestors
        return parents.iterator();
    }

    /**
     * DOCUMENT ME!
     * 
     * @param c DOCUMENT ME!
     * @param t DOCUMENT ME!
     */
    public void addTypeForContext(TypeContext c, Type t) {
        typesForContext.put(c, t);
    }

    /**
     * DOCUMENT ME!
     * 
     * @param c DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    public Type getTypeForContext(TypeContext c) {
        return (Type) typesForContext.get(c);
    }

    /**
     * DOCUMENT ME!
     * 
     * @param t DOCUMENT ME!
     * @return DOCUMENT ME!
     */
    public boolean isDescendantOf(Type t) {
        for (Iterator i = parentIterator(); i.hasNext();) {
            Type parent = (Type) i.next();

            if (parent.equals(t) || parent.isDescendantOf(t)) {
                return true;
            }
        }

        return false;
    }

    /**
     * DOCUMENT ME!
     * 
     * @return DOCUMENT ME!
     */
    public String toString() {
        return "Type[" + identification
                + (SHOW_PARENTS ? (" parents=" + parents) : "") + "]";
    }
}

/*
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific language governing rights and limitations under the License. The
 * Original Code is: all this file. The Initial Developer of the Original Code
 * is: Tomas Pitner, Masaryk University in Brno, Czech Republic. Contributor(s):
 */
